package basicnode

import (
	dms3ld "gitlab.dms3.io/ld/go-ld-prime"
	"gitlab.dms3.io/ld/go-ld-prime/node/mixins"
)

var (
	_ dms3ld.Node          = plainInt(0)
	_ dms3ld.NodePrototype = Prototype__Int{}
	_ dms3ld.NodeBuilder   = &plainInt__Builder{}
	_ dms3ld.NodeAssembler = &plainInt__Assembler{}
)

func NewInt(value int64) dms3ld.Node {
	v := plainInt(value)
	return &v
}

// plainInt is a simple boxed int that complies with dms3ld.Node.
type plainInt int64

// -- Node interface methods -->

func (plainInt) Kind() dms3ld.Kind {
	return dms3ld.Kind_Int
}
func (plainInt) LookupByString(string) (dms3ld.Node, error) {
	return mixins.Int{TypeName: "int"}.LookupByString("")
}
func (plainInt) LookupByNode(key dms3ld.Node) (dms3ld.Node, error) {
	return mixins.Int{TypeName: "int"}.LookupByNode(nil)
}
func (plainInt) LookupByIndex(idx int64) (dms3ld.Node, error) {
	return mixins.Int{TypeName: "int"}.LookupByIndex(0)
}
func (plainInt) LookupBySegment(seg dms3ld.PathSegment) (dms3ld.Node, error) {
	return mixins.Int{TypeName: "int"}.LookupBySegment(seg)
}
func (plainInt) MapIterator() dms3ld.MapIterator {
	return nil
}
func (plainInt) ListIterator() dms3ld.ListIterator {
	return nil
}
func (plainInt) Length() int64 {
	return -1
}
func (plainInt) IsAbsent() bool {
	return false
}
func (plainInt) IsNull() bool {
	return false
}
func (plainInt) AsBool() (bool, error) {
	return mixins.Int{TypeName: "int"}.AsBool()
}
func (n plainInt) AsInt() (int64, error) {
	return int64(n), nil
}
func (plainInt) AsFloat() (float64, error) {
	return mixins.Int{TypeName: "int"}.AsFloat()
}
func (plainInt) AsString() (string, error) {
	return mixins.Int{TypeName: "int"}.AsString()
}
func (plainInt) AsBytes() ([]byte, error) {
	return mixins.Int{TypeName: "int"}.AsBytes()
}
func (plainInt) AsLink() (dms3ld.Link, error) {
	return mixins.Int{TypeName: "int"}.AsLink()
}
func (plainInt) Prototype() dms3ld.NodePrototype {
	return Prototype__Int{}
}

// -- NodePrototype -->

type Prototype__Int struct{}

func (Prototype__Int) NewBuilder() dms3ld.NodeBuilder {
	var w plainInt
	return &plainInt__Builder{plainInt__Assembler{w: &w}}
}

// -- NodeBuilder -->

type plainInt__Builder struct {
	plainInt__Assembler
}

func (nb *plainInt__Builder) Build() dms3ld.Node {
	return nb.w
}
func (nb *plainInt__Builder) Reset() {
	var w plainInt
	*nb = plainInt__Builder{plainInt__Assembler{w: &w}}
}

// -- NodeAssembler -->

type plainInt__Assembler struct {
	w *plainInt
}

func (plainInt__Assembler) BeginMap(sizeHint int64) (dms3ld.MapAssembler, error) {
	return mixins.IntAssembler{TypeName: "int"}.BeginMap(0)
}
func (plainInt__Assembler) BeginList(sizeHint int64) (dms3ld.ListAssembler, error) {
	return mixins.IntAssembler{TypeName: "int"}.BeginList(0)
}
func (plainInt__Assembler) AssignNull() error {
	return mixins.IntAssembler{TypeName: "int"}.AssignNull()
}
func (plainInt__Assembler) AssignBool(bool) error {
	return mixins.IntAssembler{TypeName: "int"}.AssignBool(false)
}
func (na *plainInt__Assembler) AssignInt(v int64) error {
	*na.w = plainInt(v)
	return nil
}
func (plainInt__Assembler) AssignFloat(float64) error {
	return mixins.IntAssembler{TypeName: "int"}.AssignFloat(0)
}
func (plainInt__Assembler) AssignString(string) error {
	return mixins.IntAssembler{TypeName: "int"}.AssignString("")
}
func (plainInt__Assembler) AssignBytes([]byte) error {
	return mixins.IntAssembler{TypeName: "int"}.AssignBytes(nil)
}
func (plainInt__Assembler) AssignLink(dms3ld.Link) error {
	return mixins.IntAssembler{TypeName: "int"}.AssignLink(nil)
}
func (na *plainInt__Assembler) AssignNode(v dms3ld.Node) error {
	if v2, err := v.AsInt(); err != nil {
		return err
	} else {
		*na.w = plainInt(v2)
		return nil
	}
}
func (plainInt__Assembler) Prototype() dms3ld.NodePrototype {
	return Prototype__Int{}
}
